<?php
$DEMO_MODE = FALSE;
$READ_ONLY_MODE = FALSE;
$base_url = "./../";
require_once(dirname(__FILE__) . '/../includes/utils.php');
require_once(dirname(__FILE__) . '/../includes/guestbook.php');
require_once(dirname(__FILE__) . '/../includes/views.php');
require_once(dirname(__FILE__) . '/../config.php');
confirm_install();
session_start();
if(!isset($_SESSION['username']) || !isset($_SESSION['admin']))
{
relative_location('../login.php');
exit();
}
if($_SESSION['admin'] !== "TRUE")
{
relative_location('..');
exit();
}
if(isset($_REQUEST['action']))
{
global $READ_ONLY_MODE;
global $DEMO_MODE;
$action = $_REQUEST['action'];
switch($action)
{
case "delete":
if($READ_ONLY_MODE === FALSE && $DEMO_MODE === FALSE && isset($_POST['id'])) 
{
guestbook_delete_entries($_POST['id'], (isset($_POST['banip']) && $_POST['banip'] == "true") );
}
show_entries_admin();
break;
case "showbans":
show_bans_admin();
break;
case "unban";
if($READ_ONLY_MODE === FALSE && $DEMO_MODE === FALSE && isset($_POST['id'])) 
{
unban($_POST['id']);
}
show_bans_admin();
break;
case "showbadwords":
show_bad_words_admin();
break;
case "removebadword";
if($READ_ONLY_MODE === FALSE && $DEMO_MODE === FALSE && isset($_POST['id'])) 
{
remove_bad_word($_POST['id']);
}
show_bad_words_admin();
break;
case "addbadword";
if($READ_ONLY_MODE === FALSE && $DEMO_MODE === FALSE && isset($_POST['word'])) 
{
bad_word_add($_POST['word']);
}
show_bad_words_admin();
break;
case "logout":
$_SESSION = array();
if(isset($_COOKIE[session_name()])) setcookie(session_name(), '', time()-7200, '/');
session_destroy();
relative_location('../login.php');
exit();
default:
die('Error,invalid action.');
}
}else{
show_entries_admin();
}
##########
function show_logout_button() 
{
?>
<form method="post" action=".">
<input type="hidden" name="action" value="logout"/>
<input type="submit" value="Logout"/>
</form>
<?php
}
##########
function show_checkboxes_js($formName) 
{
?>
<script type="text/javascript">
//<![CDATA[
function changeAllCheckboxes(checked) 
{
var entriesForm = document.getElementById("<?php echo $formName; ?>");
for (i = 0; i < entriesForm.length; i++) 
{
if(entriesForm.elements[i].name == "id[]") 
{
entriesForm.elements[i].checked = checked;
}
}
}
//]]>
</script>
<?php
}
##########
function show_bans_admin() 
{
include_from_template('header.php');
show_logout_button();
show_checkboxes_js("bansForm");
?>
&#171; <a href=".">Back to comments</a>
<br/>
&#171; <a href=".?action=showbadwords">Back to banned words</a>
<br/>
<br/>
<form method="post" action="." id="bansForm">
<input type="hidden" name="action" value="unban"/>
<input type="submit" value="Unban checked"/>
<br/>
<br/>
&#164; <a href="#" onclick="changeAllCheckboxes(true); return false;">Check All</a>
<br/>
&#164; <a href="#" onclick="changeAllCheckboxes(false); return false;">Uncheck All</a>
<br/>
<?php
show_bans();
?>
</form>
<?php
include_from_template('footer.php');
}
##########
function show_bad_word_add_form() 
{
global $MAX_BAD_WORD_LENGTH;
?>
<form method="post" action=".">
Word:
<input type="text" name="word" id="word" maxlength="<?php echo htmlspecialchars($MAX_BAD_WORD_LENGTH); ?>"/>
<input type="hidden" name="action" value="addbadword"/>
<input type="submit" value="Bann"/>
</form>
<?php
}
##########
function show_bad_words_admin() 
{
include_from_template('header.php');
show_logout_button();
show_checkboxes_js("badWordsForm");
?>
&#171;  <a href=".">Back to comments</a>
<br/>
&#171; <a href=".?action=showbans">Back to banned ips</a>
<br/>
<br/>
<?php show_bad_word_add_form(); ?>
<form method="post" action="." id="badWordsForm">
<input type="hidden" name="action" value="removebadword" />
<input type="submit" value="Remove checked"/>
<br/>
<br/>
&#164; <a href="#" onclick="changeAllCheckboxes(true); return false;">Check all</a>
<br/>
&#164; <a href="#" onclick="changeAllCheckboxes(false); return false;">Uncheck all</a>
<br/>
<?php
show_bad_words();
?>
</form>
<?php
include_from_template('footer.php');
}
##########
function show_entries_admin()
{
include_from_template('header.php');
show_logout_button();
show_checkboxes_js("entriesForm");
?>
&#187; <a href=".?action=showbans">View banned ips</a>
<br/>
&#187; <a href=".?action=showbadwords">View banned words</a>
<br/>
<br/>
<form method="post" action="." id="entriesForm">
<input type="hidden" name="action" value="delete" />
<input type="submit" value="Delete checked"/>
<br/>
<br/>
Bann ip of comment checked to be deleted? <input type="checkbox" name="banip" value="true"/>
<br/>
&#164; <a href="#" onclick="changeAllCheckboxes(true); return false;">Check All</a>
<br/>
&#164; <a href="#" onclick="changeAllCheckboxes(false); return false;">Uncheck All</a>
<br/>
<br/>
<?php
show_entries(NULL, NULL, TRUE, TRUE, TRUE);
?>
</form>
<?php
include_from_template('footer.php');
}
?>